<template>
  <b-container
    class="full-width-container"
  >
    <confirmation-modal
      ref="confirmationModal"
      variant="primary"
    />
    <div v-if="status === LIST_STATUS.LOADING">
      <content-loader-table :num-rows="10" />
    </div>
    <div v-else-if="status === LIST_STATUS.ERROR">
      <b-list-group>
        <b-list-group-item variant="danger">
          <h5>Error Loading Filters</h5>
          <p>There was an error loading your filters.</p>
          <pre>{{ JSON.stringify(error, null, 2) }}</pre>
        </b-list-group-item>
      </b-list-group>
    </div>
    <div v-show="status === LIST_STATUS.SUCCESS">
      <!--
        When the list loads successfully, some actions on already loaded filters could
        result in errors. The following <b-alert /> elements display those errors
      -->
      <b-alert
        v-model="showVisibilityError"
        class="mb-2"
        dismissible
        variant="danger"
      >
        <h5>Error changing filter visibility</h5>
        <pre>{{ visibilityErrorMsg }}</pre>
      </b-alert>
      <div class="d-flex justify-content-between">
        <div>
          <b-button
            :to="{ name: 'filterCreate' }"
            size="sm"
            variant="success"
          >
            <font-awesome-icon icon="plus" />
          </b-button>
        </div>
        <div class="d-flex align-items-baseline">
          <b-form inline>
            <b-form-select
              v-model="perPage"
              :options="pageOptions"
              class="mr-2"
              size="sm"
            />
          </b-form>
          <b-pagination
            v-model="currentPage"
            :per-page="perPage"
            :total-rows="count"
            align="right"
            size="sm"
          />
        </div>
      </div>
      <b-table
        ref="filterTableList"
        :current-page="currentPage"
        :fields="fields"
        :items="fetchList"
        :per-page="perPage"
        :sort-by.sync="sortBy"
        :sort-desc.sync="sortDesc"
        bordered
        hover
      >
        <template #head(updated_at)="data">
          <div>
            {{ data.label }}
            <b-badge
              v-b-tooltip.hover.right
              pill
              title="This field reflects the last time the filter record was changed.
              It does not reflect changes to any filter version or other related data"
              variant="secondary"
            >
              ?
            </b-badge>
          </div>
        </template>
        <template #cell(name)="data">
          <b-link
            :to="{
              name: (showAdminView ? 'adminFilterDetail' : 'filterDetail'),
              params: { filterId: data.item.id },
            }"
          >
            {{ data.item.name }}
          </b-link>
        </template>
        <template #cell(owner)="data">
          <div v-if="!data.value" />
          <div v-else-if="data.value.name">
            {{ data.value.name }}
            <br>
            (<a :href="`mailto:${data.value.email}`">{{ data.value.email }}</a>)
          </div>
          <div v-else>
            <a :href="`mailto:${data.value.email}`">{{ data.value.email }}</a>
          </div>
        </template>
        <template #cell(public)="data">
          <b-form-checkbox
            v-model="data.item.public"
            :disabled="togglingVisibility"
            class="text-center"
            switch
            @change="toggleVisibility(data.item)"
          />
        </template>
        <template #cell(description)="data">
          <div
            style="
              max-width: 600px;
              overflow: hidden;
              white-space: nowrap;
              text-overflow: ellipsis;
            "
          >
            {{ data.value }}
          </div>
        </template>
        <template #cell(enabled)="data">
          <div class="text-center enabled-cell">
            <div v-if="data.item.enabled">
              <b-badge
                pill
                variant="success"
              >
                Yes
              </b-badge>
              <br>
              <span>Version #{{ data.item.enabled_version.id }}</span>
            </div>
            <div v-else>
              <b-badge
                pill
                variant="secondary"
              >
                No
              </b-badge>
            </div>
          </div>
        </template>
      </b-table>
    </div>
  </b-container>
</template>

<script lang="ts">
/* eslint-disable no-param-reassign */
import Vue from 'vue';
import {
  BModal, BTable, BvTableCtxObject, BvTableFieldArray,
} from 'bootstrap-vue';
import { FilterServiceListResponse } from '@/api/services/filter';
import { LIST_STATUS } from '@/common/constants';
import { Filter } from '@/common/types';
import ConfirmationModal from '@/components/ConfirmationModal.vue';
import ContentLoaderTable from '@/components/ContentLoaderTable.vue';

const BASE_FIELDS: BvTableFieldArray = [
  {
    key: 'name',
    label: 'Name',
    sortable: false,
  },
  {
    key: 'public',
    label: 'Public',
    sortable: true,
  },
  {
    key: 'description',
    label: 'Description',
    sortable: true,
  },
  {
    key: 'created_at',
    label: 'Created At (UTC)',
    sortable: true,
    formatter: 'formatISODate',
  },
  {
    key: 'updated_at',
    label: 'Updated At (UTC)',
    sortable: true,
    formatter: 'formatISODate',
  },
  {
    key: 'enabled',
    label: 'Enabled',
  },
];

export default Vue.extend({
  components: {
    ConfirmationModal,
    ContentLoaderTable,
  },

  props: {
    error: {
      default: () => ({}),
      type: Object,
    },
    fetchFilters: {
      required: true,
      type: Function,
    },
    showAdminView: {
      default: false,
      type: Boolean,
    },
    status: {
      required: true,
      type: String,
    },
    toggleFilterVisibility: {
      required: true,
      type: Function,
    },
    visibilityErrorMsg: {
      required: true,
      type: String,
    },
  },

  data() {
    return {
      count: 0,
      currentPage: 1,
      LIST_STATUS,
      pageOptions: [5, 10, 25, 50, 100],
      perPage: 5,
      showVisibilityError: false,
      sortBy: 'created_at',
      sortDesc: true,
      togglingVisibility: false,
    };
  },

  computed: {
    fields(): BvTableFieldArray {
      const extendedFields = [
        {
          key: 'owner',
          label: 'Author',
        },
      ];
      const [firstField, ...restFields] = BASE_FIELDS;
      return [
        firstField,
        ...(this.showAdminView ? extendedFields : []),
        ...restFields,
      ];
    },
  },

  watch: {
    visibilityErrorMsg(msg: string) {
      this.showVisibilityError = msg !== '';
    },
  },

  methods: {
    async fetchList(ctx: BvTableCtxObject) {
      try {
        const { data, meta: { count } } = await this.fetchFilters({
          page: {
            limit: ctx.perPage,
            offset: (ctx.currentPage - 1) * ctx.perPage,
          },
          ...(ctx.sortBy && { sort: (ctx.sortDesc ? '-' : '') + ctx.sortBy }),
        }) as FilterServiceListResponse;
        this.count = count;
        return data;
      } catch (errors) {
        return null;
      }
    },
    async toggleVisibility(filter: Filter) {
      const prevVisibility = !filter.public;
      this.togglingVisibility = true;
      await this.$nextTick();
      const confirm = await (this.$refs.confirmationModal as BModal).prompt(
        `Are you sure you want to make the filter "${filter.name}" ${filter.public ? 'public' : 'private'}?`,
        filter.name,
      );
      if (!confirm) {
        filter.public = prevVisibility;
        this.togglingVisibility = false;
        return;
      }
      const success = await this.toggleFilterVisibility(filter);
      if (success) {
        (this.$refs.filterTableList as BTable).refresh();
      } else {
        this.showVisibilityError = true;
        filter.public = prevVisibility;
      }
      this.togglingVisibility = false;
    },
  },
});
</script>

<style>
.enabled-cell .badge {
  font-size: 100%;
}
.enabled-cell .badge-pill {
  padding-left: 1rem;
  padding-right: 1rem;
}
</style>
